<?php
/**
 * @component Encrypt Configuration component
 * @author Ratmil Torres
 * @copyright (C) Ratmil Torres
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

defined( '_JEXEC' ) or die( 'Restricted access' );

require_once(JPATH_ADMINISTRATOR . DS . "components" . DS . "com_encrypt_configuration" . DS . "xmlimport.php");
require_once(JPATH_ADMINISTRATOR . DS . "components" . DS . "com_encrypt_configuration" . DS . "xmlexport.php");

function uninstall_encryption_plugin()
{
	$version = new JVersion;
	if($version->RELEASE == "1.5")
	{
		$db =& JFactory::getDBO();
		$db->setQuery("DELETE FROM #__plugins WHERE element='encrypt' AND folder='system'");
		$db->query();
		$dest_folder = JPATH_SITE.DS.'plugins'.DS.'system'.DS.'encrypt';
		if(JFolder::exists($dest_folder))
		{
			JFolder::delete($dest_folder);
		}
		$dest_file_php = JPATH_SITE.DS.'plugins'.DS.'system'.DS.'encrypt.php';
		if(JFile::exists($dest_file_php))
		{
			JFile::delete($dest_file_php);
		}
		$dest_file_xml = JPATH_SITE.DS.'plugins'.DS.'system'.DS.'encrypt.xml';
		if(JFile::exists($dest_file_xml))
		{
			JFile::delete($dest_file_xml);
		}
	}
	else if($version->RELEASE >= "1.6")
	{
		$db = JFactory::getDBO();
		$db->setQuery("DELETE FROM #__extensions WHERE element='encrypt' AND folder='system' AND type='plugin'");
		$db->query();
		$dest_folder = JPATH_SITE.DS.'plugins'.DS.'system'.DS.'encrypt';
		if(JFolder::exists($dest_folder))
		{
			JFolder::delete($dest_folder);
		}
	}
}

function install_encryption_plugin()
{
	uninstall_encryption_plugin();
	$version = new JVersion;
	if($version->RELEASE == "1.5")
	{
		$dest_folder = JPATH_SITE.DS.'plugins'.DS.'system'.DS.'encrypt';
		$dest_file_php = JPATH_SITE.DS.'plugins'.DS.'system'.DS.'encrypt.php';
		$dest_file_xml = JPATH_SITE.DS.'plugins'.DS.'system'.DS.'encrypt.xml';
		$result = true;
		$db =& JFactory::getDBO();
		$folder = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_encrypt_configuration'.DS.'extensions'.DS.'encrypt';
		if(!JFolder::exists($folder) || !JFolder::copy($folder, $dest_folder))
		{
			echo "Error copying encrypt folder to plugins folder<br/>";
			$result = false;
		}
		$file_php = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_encrypt_configuration'.DS.'extensions'.DS.'encrypt.php';
		if(!JFile::exists($file_php) || !JFile::copy($file_php, $dest_file_php))
		{
			echo "Error copying encrypt.php file to plugins folder<br/>";
			$result = false;
		}
		$file_xml = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_encrypt_configuration'.DS.'extensions'.DS.'encrypt.xml';
		if(!JFile::exists($file_xml) || !JFile::copy($file_xml, $dest_file_xml))
		{
			echo "Error copying encrypt.xml file to plugins folder<br/>";
			$result = false;
		}
		$query = "INSERT INTO #__plugins(name, element, folder, published) VALUES('System-Password Encrypt', 'encrypt', 'system', 1)";
		$db->setQuery($query);
		if(!$db->query())
		{
			echo "Error inserting plugin record<br/>";
			$result = false;
		}
		if(!$result)
			unistall_encryption_plugin();
		return $result;
	}
	else if($version->RELEASE >= "1.6")
	{
		$dest_folder = JPATH_SITE.DS.'plugins'.DS.'system'.DS.'encrypt'.DS.'encrypt';
		$dest_folder_path = JPATH_SITE.DS.'plugins'.DS.'system'.DS.'encrypt';
		$dest_file_php = JPATH_SITE.DS.'plugins'.DS.'system'.DS.'encrypt'.DS.'encrypt.php';
		$dest_file_xml = JPATH_SITE.DS.'plugins'.DS.'system'.DS.'encrypt'.DS.'encrypt.xml';
		$result = true;
		$db = JFactory::getDBO();
		JFolder::create($dest_folder_path);
		$folder = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_encrypt_configuration'.DS.'extensions'.DS.'encrypt';
		if(!JFolder::exists($folder) || !JFolder::copy($folder, $dest_folder))
		{
			echo "Error copying encrypt folder to plugins folder ($folder) ($dest_folder)<br/>";
			$result = false;
		}
		$file_php = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_encrypt_configuration'.DS.'extensions'.DS.'encrypt.php';
		if(!JFile::exists($file_php) || !JFile::copy($file_php, $dest_file_php))
		{
			echo "Error copying encrypt.php file to plugins folder ($file_php) ($dest_file_php)<br/>";
			$result = false;
		}
		$file_xml = JPATH_ADMINISTRATOR.DS.'components'.DS.'com_encrypt_configuration'.DS.'extensions'.DS.'encrypt.xml';
		if(!JFile::exists($file_xml) || !JFile::copy($file_xml, $dest_file_xml))
		{
			echo "Error copying encrypt.xml file to plugins folder ($file_xml) ($dest_file_xml)<br/>";
			$result = false;
		}
		
		$query = "INSERT INTO #__extensions(name, type, element, folder, enabled, access) 
			VALUES('System-Password Encrypt', 'plugin', 'encrypt', 'system', 1, 1)";
		$db->setQuery($query);
		if(!$db->query())
		{
			echo "Error inserting plugin record<br/>";
			$result = false;
		}
		if(!$result)
			unistall_encryption_plugin();
		return $result;
	}
	return false;
}

function backupCurrentData()
{
	$filePath = JPATH_ROOT.DS.'tmp'.DS.'encrypt_plugin.bk.xml';
	jimport('joomla.filesystem.file');
	if(JFile::exists($filePath))
		JFile::delete($filePath);
	$exporter = new XML_Exporter();
	if($exporter->open($filePath))
	{
		$exporter->write_root_open("encrypt");
		$exporter->export_table("encrypt_controls", "control_key", "has_default_data=\"yes\"");
		$exporter->write_root_close();
		$exporter->close();
	}
}

function restoreData()
{
	$filePath = JPATH_ROOT.DS.'tmp'.DS.'encrypt_plugin.bk.xml';
	$importer = new XML_Importer();
	if(!$importer->importFromXml($filePath, "ENCRYPT_"))
	{
		echo $importer->errorMsg."<br/>";
	}
	jimport('joomla.filesystem.file');
	if(JFile::exists($filePath))
		JFile::delete($filePath);
}

function dropPreviousTables()
{
	$db = JFactory::getDBO();
	$db->setQuery("DROP TABLE IF EXISTS `#__encrypt_keys`");
	if(!$db->query())
	{
		echo $db->stderr()."<br/>";
	}
	$db->setQuery("DROP TABLE IF EXISTS `#__encrypt_controls`");
	if(!$db->query())
	{
		echo $db->stderr()."<br/>";
	}
	$db->setQuery("DROP TABLE IF EXISTS `#__encrypt_gendata`");
	if(!$db->query())
	{
		echo $db->stderr()."<br/>";
	}
	
	$db->setQuery("DROP TABLE IF EXISTS `#__encrypt_access_lock`");
	if(!$db->query())
	{
		echo $db->stderr()."<br/>";
	}
	
}

function setDefaultKeysGenTime()
{
	$db = JFactory::getDBO();
	$db->setQuery("UPDATE #__encrypt_keys SET gen_time = NOW() WHERE gen_time IS NULL");
	$db->query();
}

function installNewTables()
{
	$db = JFactory::getDBO();
	
		
	$query = "CREATE TABLE `#__encrypt_keys` (
		  `keys_id` int(11) NOT NULL auto_increment,
		  `algorithm` tinyint(3) NOT NULL default '1',
		  `private_key` text NOT NULL,
		  `e` text NOT NULL,
		  `n` text NOT NULL,
		  `d` int NULL, `m` int NULL,
		  `e10` int NULL,
		  `d10` int NULL,
		  `m10` int NULL,
		  `random_des` tinyint(3) NOT NULL default '1',
		  `des_key` varchar(255) NOT NULL,
		  `encrypted_key` tinyint(3) NOT NULL default '0',
		  `gen_time` datetime NULL,
		  PRIMARY KEY  (`keys_id`)
		) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;";
	$db->setQuery($query);
	if(!$db->query())
	{
		echo $db->stderr()."<br/>";
	}
	$query = "CREATE TABLE `#__encrypt_controls` (
		  control_key int(11) NOT NULL auto_increment,
		  description varchar(255),
		  form_id varchar(255),
		  form_name varchar(255),
		  control_id varchar(255),
		  control_name varchar(255),
		  encrypt_empty int(11),
		  control_minlength int(11),
		  option_filter varchar(255),
		  insertSubmitBefore varchar(255),
		  enabled int(11) default '1',
		  insertBeforeOnSubmit int(11),
		  backEnd int(11),
		  frontEnd int(11),	
		  view_filter varchar(255),
		  show_signal int(11) default '0',	
		  PRIMARY KEY  (`control_key`)
		) ENGINE=MyISAM;";
	$db->setQuery($query);
	if(!$db->query())
	{
		echo $db->stderr()."<br/>";
	}
	
	
	$query = "CREATE TABLE `#__encrypt_access_lock` (
			lock_value int(11),
			in_use int(11)
		)ENGINE=InnoDB;";
	$db->setQuery($query);
	if(!$db->query())
	{
		echo $db->stderr()."<br/>";
	}
	
	$query = "INSERT INTO #__encrypt_access_lock(lock_value, in_use) VALUES(0, 0)";
	$db->setQuery($query);
	if(!$db->query())
	{
		echo $db->stderr()."<br/>";
	}
	
	$query = "CREATE TABLE `#__encrypt_gendata` (
		  gen_key int(11) NOT NULL auto_increment,
		  gen_data text NULL,
		  PRIMARY KEY  (`gen_key`)
		) ENGINE=MyISAM;";
	$db->setQuery($query);
	if(!$db->query())
	{
		echo $db->stderr()."<br/>";
	}	
	
	$algorithm = 2;
	$private_key = "-----BEGIN RSA PRIVATE KEY-----
MIICXAIBAAKBgQCreTknt5KE5RKJJMKYcO8bxm9KRsuNGhbMpsFQU7r//7XxO9Z5TsOJWK4BZtGl
QUWR+uqAYnxDgs/BMwPIkTXw4sxn8BZ+5JepLXSa0iDxHDVAfKZgYZeTU7U0wqRYKSa0f2y6gRYE
zUXQzwC30XSnLLTO7UzcDslnljENmXyCowIDAQABAoGAA719qymcZwyuFlK4ceXIuWTfKZIYv4ep
pqYegleJNStJNy1UdMnshvLpvLsW6JFfaJs+ATXkuv4/9NldhELyl7jTRcZbg/Ee7mYIebt1BjLe
gqkVQxBx2MX2O5nn/0BmBxBP+pdOhS0BA1R9Uo05vhF1R+vDDXBr35FvxJpdfNECQQDnacEamxI8
40zryHmRo8kwDnsD2cXdDJ9mBtxg1qPsYEbuT4MBGYXYfJFT+IgXJZuesvCO9SbkWuMW/E8A65jT
AkEAvbEpc71z4jKzTCvbx4/AsypZBSAHuML3i1zwwd1BjZTUHvDSRD30QGpGGzHn0S3FxAcsWgyi
uY2XJ9e0GIFM8QJASDaNJuNLPqrjnxRRM2x75L4wDxSPFRrSRwFPFf0E7Edi+wze4aH4TYUZyK1e
snJu7IgEX2gK+emOweZ8NNpQNwJAIbYddstBj/6QrMXSnkmm5nBtN6L0nFpR4fuXceyfXMkJVaJY
y/XytYvtf6HD4AHxdqALuskqFi3aoiMMh5pbEQJBAIu4dl1IcAweENEoIdaJvG/RshMNoGI7kDUy
giijOCCt6xjBUucVFVftbBrDQYzvX+/ZCxUSlQX7BHR5hKu8/4Q=
-----END RSA PRIVATE KEY-----";
	$private_key = $db->getEscaped($private_key);
	$query = "INSERT INTO #__encrypt_keys(algorithm, private_key, e, n, des_key, gen_time)
		VALUES($algorithm, 
			'$private_key', 
			'10001', 
			'ab793927b79284e5128924c29870ef1bc66f4a46cb8d1a16cca6c15053baffffb5f13bd6794ec38958ae0166d1a5414591faea80627c4382cfc13303c89135f0e2cc67f0167ee497a92d749ad220f11c35407ca66061979353b534c2a4582926b47f6cba811604cd45d0cf00b7d174a72cb4ceed4cdc0ec96796310d997c82a3', 
			'534656jdsf787GERT453', '2000-05-22 09:19:35')";
	$db->setQuery($query);
	if(!$db->query())
	{
		echo $db->stderr()."<br/>";
	}
	
	$version = new JVersion;
	if($version->RELEASE == "1.5")
	{
		$query = "INSERT INTO #__encrypt_controls
		(description, form_id, form_name, control_id, control_name, 
		encrypt_empty, control_minlength, option_filter, insertSubmitBefore, enabled, insertBeforeOnSubmit, backEnd, frontEnd,
		view_filter)
		VALUES
		('Back-end login', 'form-login', 'login', 'modlgn_passwd', 'passwd', 1, 0, '', 'login.submit\\\\(\\\\);', 1, 1, 1, 0, ''),
		('Front-end login', 'form-login', 'login', 'modlgn_passwd', 'passwd', 1, 0, '', '', 1, 1, 0, 1, ''),
		('Front-end login', 'com-form-login', 'com-login', 'passwd', 'passwd', 1, 0, 'com_user', '', 1, 1, 0, 1, 'login'),
		('Front-end create account password', 'josForm', 'josForm', 'password', 'password', 0, 4, 'com_user', '', 1, 1, 0, 1, 'register'),
		('Front-end create account password verify', 'josForm', 'josForm', 'password2', 'password2', 0, 4, 'com_user', '', 1, 1, 0, 1, 'register'),
		('Front-end edit profile password', '', 'userform', 'password', 'password', 0, 4, 'com_user', '', 1, 1, 0, 1, 'user'),
		('Front-end edit profile password verify', '', 'userform', 'password2', 'password2', 0, 4, 'com_user', '', 1, 1, 0, 1, 'user'),
		('Front-end change password', '', '', 'password1', 'password1', 0, 0, 'com_user', '', 1, 1, 0, 1, 'reset'),
		('Front-end change password verify', '', '', 'password2', 'password2', 0, 0, 'com_user', '', 1, 1, 0, 1, 'reset'),
		('Joomla off-line login', 'form-login', 'login', 'passwd', 'passwd', 0, 0, '', '', 1, 1, 0, 1, ''),
		('Back-end edit profile password', '', 'adminForm', 'password', 'password', 0, 0, 'com_users', '', 1, 1, 1, 0, 'user'),
		('Back-end edit profile password verify', '', 'adminForm', 'password2', 'password2', 0, 0, 'com_users', '', 1, 1, 1, 0, 'user'),
		('Update RSA private KEY', '', 'adminForm', 'decryptkey', 'decryptkey', 1, 0, 'com_encrypt_configuration', '', 1, 1, 1, 0, '');";
	}
	else
	{
		$query = "INSERT INTO #__encrypt_controls
		(description, form_id, form_name, control_id, control_name, 
		encrypt_empty, control_minlength, option_filter, insertSubmitBefore, enabled, insertBeforeOnSubmit, backEnd, frontEnd,
		view_filter)
		VALUES
		('Back-end login', 'form-login', '', 'mod-login-password', 'passwd', 1, 0, '', 'document.getElementById\\\\(\'form-login\'\\\\).submit\\\\(\\\\);', 1, 1, 1, 0, ''),
		('Back-end my profile', 'profile-form', 'adminForm', 'jform_password', 'jform[password]', 1, 0, 'com_admin', '', 1, 1, 1, 0, 'profile'),
		('Back-end my profile verify', 'profile-form', 'adminForm', 'jform_password2', 'jform[password2]', 1, 0, 'com_admin', '', 1, 1, 1, 0, 'profile'),
		('Front-end login module', 'login-form', '', 'modlgn-passwd', 'password', 1, 0, '', '', 1, 1, 0, 1, ''),
		('Front-end login', '', '', 'password', 'password', 1, 0, 'com_users', '', 1, 1, 0, 1, 'login'),
		('Front-end create account password', 'member-registration', '', 'jform_password1', 'jform[password1]', 0, 4, 'com_users', '', 1, 1, 0, 1, 'registration'),
		('Front-end create account password verify', 'member-registration', '', 'jform_password2', 'jform[password2]', 0, 4, 'com_users', '', 1, 1, 0, 1, 'registration'),
		('Front-end edit profile password', 'member-profile', '', 'jform_password1', 'jform[password1]', 0, 4, 'com_users', '', 1, 1, 0, 1, 'profile'),
		('Front-end edit profile password verify', 'member-profile', '', 'jform_password2', 'jform[password2]', 0, 4, 'com_users', '', 1, 1, 0, 1, 'profile'),
		('Front-end change password', '', '', 'jform_password1', 'jform[password1]', 0, 0, 'com_users', '', 1, 1, 0, 1, 'profile'),
		('Front-end change password verify', '', '', 'jform_password2', 'jform[password2]', 0, 0, 'com_users', '', 1, 1, 0, 1, 'profile'),
		('Joomla off-line login', 'form-login', 'login', 'passwd', 'password', 0, 0, '', '', 1, 1, 0, 1, ''),
		('Back-end edit profile password', 'user-form', 'adminForm', 'jform_password', 'jform[password]', 0, 0, 'com_users', '', 1, 1, 1, 0, 'user'),
		('Back-end edit profile password verify', 'user-form', 'adminForm', 'jform_password2', 'jform[password2]', 0, 0, 'com_users', '', 1, 1, 1, 0, 'user'),
		('Update RSA private KEY', '', 'adminForm', 'decryptkey', 'decryptkey', 1, 0, 'com_encrypt_configuration', '', 1, 1, 1, 0, '');";
	}
	$db->setQuery($query);
	if(!$db->query())
	{
		echo $db->stderr()."<br/>";
	}
}

function showGenerationLink()
{
}

function com_install()
{
	backupCurrentData();
	dropPreviousTables();
	installNewTables();
	restoreData();
	setDefaultKeysGenTime();
	install_encryption_plugin();
}
?>