<?php

/**
 * @component Encrypt Configuration component
 * @author Ratmil Torres
 * @copyright (C) Ratmil Torres
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

defined( '_JEXEC' ) or die( 'Restricted access' );

class XML_Exporter
{
	var $fp;
	var $root;
	var $table_prefix;
	
	function open($filePath)
	{
		if (!($this->fp = @fopen($filePath, "w")))
			return false;
		else
			return true;
	}
	
	function close()
	{
		@fclose($this->fp);
	}
	
	function write_root_open($root)
	{
		@fwrite($this->fp, "<$root>\r\n");
		$this->root = $root;
	}
	
	function write_root_close()
	{
		$root = $this->root;
		@fwrite($this->fp, "</$root>\r\n");
	}

	function export_table($table, $table_key, $optionals = "", $cyclic_reference = "")
	{
		@fwrite($this->fp, "<rows_$table $optionals >\r\n");
		$table_name = $this->table_prefix . $table;
		$db = JFactory::getDBO();
		$query = "SELECT COUNT(*) FROM #__" .  $table_name;
		$db->setQuery( $query );
		$total = $db->loadResult();
		$count = 0;
		$query = "SELECT * FROM #__" . $table_name;
		while($count <= $total)
		{
			$db->setQuery( $query, $count, 100);
			$rows = $db->loadAssocList();
			if(is_array($rows))
			{
				foreach($rows as $row)
				{
					@fwrite($this->fp, "<".$table_name." ");
					foreach($row as $key => $value)
					{
						if(strcasecmp($key, $cyclic_reference) != 0 && $value != "" && $value != null)
							@fwrite($this->fp, " $key = \"".$this->encodeXml($value)."\"");	
					}
					@fwrite($this->fp, " />\r\n ");
				}
			}
			$count += 100;
		}
		@fwrite($this->fp, "</rows_$table>\r\n");
		if($cyclic_reference != "")
		{
			$count = 0;
			$query = "SELECT $cyclic_reference, $table_key FROM #__" . $table_name;
			@fwrite($this->fp, "<cyclic_references>\r\n");
			while($count <= $total)
			{
				$db->setQuery( $query, $count, 100);
				$rows = $db->loadAssocList();
				if(is_array($rows))
				{
					foreach($rows as $row)
					{
						$key = $row[$table_key];
						$value = $row[$cyclic_reference];
						if($value != null && $value != "" && $value != 0)
						{
							@fwrite($this->fp, "<cyclic_reference table=\"$table_name\"");
							@fwrite($this->fp, " key=\"".$this->encodeXml($table_key)."\"");
							@fwrite($this->fp, " reference=\"".$this->encodeXml($cyclic_reference)."\"");
							@fwrite($this->fp, " key_value=\"".$this->encodeXml($key)."\"");
							@fwrite($this->fp, " reference_value=\"".$this->encodeXml($value)."\"");
							@fwrite($this->fp, " />\r\n ");
						}
					}
				}
				$count += 100;
			}
			@fwrite($this->fp, "</cyclic_references>\r\n");
		}
	}

	function encodeXml($val) 
	{
		$val = str_replace("\n", '<br/>', $val);
		$val = str_replace('&', '&amp;', $val);
		$val = str_replace("'", '&apos;', $val);
		$val = str_replace('"', '&quot;', $val);
		$val = str_replace('<', '&lt;', $val);
		$val = str_replace('>', '&gt;', $val);
		return $val;
	}
	
	function setTablePrefix($table_prefix)
	{
		$this->table_prefix = $table_prefix;
	}
}

?>